/******************************************************************************/
/* PAlert header file.                                                        */
/******************************************************************************/
/* This is part of the PolyKit library.                                       */
/* Copyright (C) 1998-1999 by Polycode.                                       */
/* All rights reserved.                                                       */
/*                                                                            */
/* This source, or parts thereof, may be used for free in free- and shareware */
/* programs. For commercial programs, you have to pay a fee to use it. See    */
/* the license file for more information.                                     */
/******************************************************************************/


#ifndef __PAlert_h
#define __PAlert_h

// PolyKit headers
#include "POS.h"
#include "PString.h"
#include "PSynchronize.h"
#include "ImportExport.h"


/******************************************************************************/
/* String resource names                                                      */
/******************************************************************************/
#if __p_os == __p_beos

#define IDS_PALERT_ABORT							1
#define IDS_PALERT_RETRY							2
#define IDS_PALERT_IGNORE							3
#define IDS_PALERT_OK								4
#define IDS_PALERT_CANCEL							5
#define IDS_PALERT_YES								6
#define IDS_PALERT_NO								7

#endif



/******************************************************************************/
/* PAlert class                                                               */
/******************************************************************************/
#if __p_os == __p_beos && __POWERPC__
#pragma export on
#endif

class _IMPEXP_PKLIB PAlert
{
public:
	enum PAlertType
	{
		pInfo,
		pWarning,
		pStop,
		pQuestion
	};

	enum PAlertButtons
	{
		pAbortRetryIgnore,
		pOk,
		pOkCancel,
		pRetryCancel,
		pYesNo,
		pYesNoCancel
	};

	enum PAlertButton
	{
		pIDAbort,
		pIDRetry,
		pIDIgnore,
		pIDOk,
		pIDCancel,
		pIDYes,
		pIDNo
	};

	PAlert(PString title, PString message, PAlertType type, PAlertButtons buttons, uint8 defButton = 0);
	virtual ~PAlert(void);

	PAlertButton Show(void);

protected:
	PString alertTitle;
	PString alertMessage;
	PAlertType alertType;
	PAlertButtons alertButtons;
	uint8 alertDefault;

#if __p_os == __p_beos

	static PMutex resLocker;
	static uint32 resCounter;
	static uint32 resID;

#endif
};

#if __p_os == __p_beos && __POWERPC__
#pragma export off
#endif

#endif
